unit Usetimer;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, vg_TLB;

type
  TfrmUsetimer = class(TForm)
    vg1: Tvgctrl;
    Button1: TButton;
    Button2: TButton;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmUsetimer: TfrmUsetimer;

implementation

{$R *.dfm}
var

  timerenabled : Boolean = false;

procedure TfrmUsetimer.FormShow(Sender: TObject);
begin
  vg1.Run( 'http://www.visual-graph.com/activex/timer.xml' );
end;

procedure TfrmUsetimer.Button1Click(Sender: TObject);
var
  d : IUnit;
  b : Boolean;
begin
  d := vg1.vg.ActiveSheet.UnitByName( 'Element1' );
  b := TVarData( d.GetPropertyValue( 'Twinkle' ) ).VBoolean;
  d.SetPropertyValue( 'Twinkle', not b );
end;

procedure TfrmUsetimer.Button2Click(Sender: TObject);
begin
  if timerenabled then
    vg1.vg.ActiveSheet.SetTimer( 0 )
  else
    vg1.vg.ActiveSheet.SetTimer( 30 );
  timerenabled := not timerenabled;
end;

end.
