// AddaUnit.cpp : implementation file
//

#include "stdafx.h"
#include "vg.h"
#include "sheet.h"
#include "unit.h"
#include "VC.h"
#include "AddaUnit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AddaUnit dialog


AddaUnit::AddaUnit(CWnd* pParent /*=NULL*/)
  : CDialog(AddaUnit::IDD, pParent)
{
  //{{AFX_DATA_INIT(AddaUnit)
    // NOTE: the ClassWizard will add member initialization here
  //}}AFX_DATA_INIT
}


void AddaUnit::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(AddaUnit)
  DDX_Control(pDX, IDC_VGCTRL1, vg1);
  DDX_Control(pDX, IDC_VGCTRL2, toolbar);
  //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(AddaUnit, CDialog)
  //{{AFX_MSG_MAP(AddaUnit)
  ON_WM_SIZE()
  ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
  ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
  ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
  ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
  ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
  ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
  ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
  ON_BN_CLICKED(IDC_BUTTON8, OnButton8)
  ON_BN_CLICKED(IDC_BUTTON9, OnButton9)
  ON_BN_CLICKED(IDC_BUTTON10, OnButton10)
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// AddaUnit message handlers

BOOL AddaUnit::OnInitDialog() 
{
  CDialog::OnInitDialog();
  
    toolbar.Run("http://www.visual-graph.com/activex/addunit.xml");
    vg1.Design("");
  CSheet sheet = vg1.GetVg().GetActiveSheet();
  VARIANT v;
  v.vt = VT_DISPATCH;
  v.pdispVal = sheet.m_lpDispatch;
    toolbar.GetVg().GetActiveSheet().SetPropertyValue("cursheet", v);
  return TRUE;
}

void AddaUnit::OnSize(UINT nType, int cx, int cy) 
{
  CDialog::OnSize(nType, cx, cy);
  
  if( vg1.m_hWnd )
  {
    toolbar.MoveWindow( 0, 0, cx, 40 );
    vg1.MoveWindow( 0, 40, cx, cy - 100 );
    CWnd* bt = GetDlgItem( IDC_BUTTON1 );
    bt->MoveWindow( 0, cy - 50, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON2 );
    bt->MoveWindow( 100, cy - 50, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON3 );
    bt->MoveWindow( 200, cy - 50, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON4 );
    bt->MoveWindow( 300, cy - 50, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON5 );
    bt->MoveWindow( 400, cy - 50, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON6 );
    bt->MoveWindow( 0, cy - 30, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON7 );
    bt->MoveWindow( 100, cy - 30, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON8 );
    bt->MoveWindow( 200, cy - 30, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON9 );
    bt->MoveWindow( 300, cy - 30, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON10 );
    bt->MoveWindow( 400, cy - 30, 100, 20 );
  };
}

void AddaUnit::OnButton1() 
{
  CUnit d = vg1.GetVg().GetActiveSheet().AddUnit( NULL, "rect" );
  d.SetBounds( 0, 100, 100, 100 );
  d.SetBackColor( 0xFF00 );  
}

void AddaUnit::OnButton2() 
{
  CUnit d = vg1.GetVg().GetActiveSheet().AddUnit( NULL, "line" );
  d.SetPointCount( 2 );
  d.SetX( 0, 100 );
  d.SetY( 0, 100 );
  d.SetX( 1, 200 );
  d.SetY( 1, 200 );
  d.Refresh();
  d.SetLineWidth( 8 );
  d.SetEndArrow( 1 );
}

void AddaUnit::OnButton3() 
{
  CUnit d = vg1.GetVg().GetActiveSheet().AddUnit( NULL, "circle" );
  d.SetBounds( 200, 100, 100, 100 );
  d.SetBackColor( 0xFF );
}

void AddaUnit::OnButton4() 
{
  CUnit d = vg1.GetVg().GetActiveSheet().AddUnit( NULL, "arc" );
  d.SetBounds( 300, 100, 100, 100 );
  d.SetStartAngle( 45 );
  d.SetEndAngle( 315 );
  d.SetLineWidth( 8 );
  d.SetBackColor( 0xFF0000 );
}

void AddaUnit::OnButton5() 
{
  CUnit d = vg1.GetVg().GetActiveSheet().AddUnit( NULL, "pie" );
  d.SetBounds( 400, 100, 100, 100 );
  d.SetStartAngle( 45 );
  d.SetEndAngle( 315 );
  d.SetLineWidth( 8 );
  d.SetBackColor( 0xFF0000 );
}

void AddaUnit::OnButton6() 
{
  Cvg doc = vg1.GetVg().Create( vg1.GetDefaultPath() + "controls.tbl", true, false );
  CUnit d = vg1.GetVg().GetActiveSheet().AddUnit( doc, "button" );
  d.MoveTo( 500, 150 - d.GetHeight() / 2 );
  d.SetLib( doc.GetFileName() );
  doc.Free();
}

void AddaUnit::OnButton7() 
{
  Cvg doc = vg1.GetVg().Create( vg1.GetDefaultPath() + "controls.tbl", true, false );
  CUnit d = vg1.GetVg().GetActiveSheet().AddUnit( doc, "listbox" );
  d.SetBounds( 600, 100, 100, 100 );
  d.Execute( "AddItem( 'Item1' )" );
  d.Execute( "AddItem( 'Item2' )" );
  d.Execute( "AddItem( 'Item3' )" );
  d.SetLib( doc.GetFileName() );
  doc.Free();
}

void AddaUnit::OnButton8() 
{
  Cvg doc = vg1.GetVg().Create( vg1.GetDefaultPath() + "controls.tbl", true, false );
  CUnit d = vg1.GetVg().GetActiveSheet().AddUnit( doc, "vscrollbar" );
  d.MoveTo( 750 - d.GetWidth() / 2, 100 );
  d.SetHeight( 100 );
  d.SetLib( doc.GetFileName() );
  doc.Free();
}

void AddaUnit::OnButton9() 
{
  Cvg doc = vg1.GetVg().Create( "http://www.visual-graph.com/activex/power.xml", true, false );
  CUnit d = vg1.GetVg().GetActiveSheet().AddUnit( doc, "TransformerB" );
  d.MoveTo( 850 - d.GetWidth() / 2, 150 - d.GetHeight() / 2 );
  d.SetLib( doc.GetFileName() );
  doc.Free();
}

void AddaUnit::OnButton10() 
{
  Cvg doc = vg1.GetVg().Create( "http://www.visual-graph.com/activex/power.xml", true, false );
  CUnit d = vg1.GetVg().GetActiveSheet().AddUnit( doc, "VGround" );
  d.MoveTo( 950 - d.GetWidth() / 2, 150 - d.GetHeight() / 2 );
  d.SetLib( doc.GetFileName() );
  doc.Free();
}
