unit UseunitLink;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, vg_TLB;

type
  TfrmUseunitLink = class(TForm)
    vg1: Tvgctrl;
    Button1: TButton;
    Button2: TButton;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmUseunitLink: TfrmUseunitLink;

implementation

{$R *.dfm}

procedure TfrmUseunitLink.FormShow(Sender: TObject);
begin
  vg1.Design( 'http://www.visual-graph.com/activex/link.xml' );
end;

procedure TfrmUseunitLink.Button1Click(Sender: TObject);
var
  sheet : ISheet;
  d1, d2, d3, line1, line : IUnit;
begin
  sheet := vg1.vg.ActiveSheet;
  d1 := vg1.vg.ActiveSheet.UnitByName( 'HKnife1' );
  d2 := vg1.vg.ActiveSheet.UnitByName( 'TransformerB1' );
  d3 := vg1.vg.ActiveSheet.UnitByName( 'HSwitch1' );
  Line1 := vg1.vg.ActiveSheet.UnitByName( 'Line1' );

  line := vg1.vg.ActiveSheet.AddUnit( nil, 'line' );
  line.Execute( 'PointCount = 3; LinkMode = 1; Bytes[1] = 8; Bytes[2] = 8' );
  sheet.SetLink( d1, line, 'L2', 'P0' );
  sheet.SetLink( line, d2, 'P1', 'L1' );

  line := vg1.vg.ActiveSheet.AddUnit( nil, 'line' );
  line.Execute( 'PointCount = 3; LinkMode = 1; Bytes[1] = 8; Bytes[2] = 8' );
  sheet.SetLink( d2, line, 'L3', 'P0' );
  sheet.SetLink( line, d3, 'P1', 'L1' );

  line := vg1.vg.ActiveSheet.AddUnit( nil, 'line' );
  line.Execute( 'PointCount = 2; LinkMode = 1; Bytes[1] = 8' );
  sheet.SetLink( d2, line, 'L2', 'P0' );
  line.Execute( 'X[2] = X[0]' );
  sheet.SetLink( line, Line1, 'P1', #0 );

  d1.Refresh();
  d2.Refresh();
  d3.Refresh();
end;

procedure TfrmUseunitLink.Button2Click(Sender: TObject);
var
  i, j, n : Integer;
  e : IUnit;
  ft : string;
  d : IUnit;
begin
  i := 0;
  n := vg1.vg.ActiveSheet.UnitCount;
  while( i < n ) do
  begin
    d := vg1.vg.ActiveSheet.Units[i];
    j := 0;
    while( j < d.LinkCount ) do
    begin
      e := d.Links[j];
      ft := d.LinkFoots[j];
      vg1.vg.Selection.Clear();
      vg1.vg.Selection.Add( d );
      ShowMessage( 'Unit ' + d.Name + ' links to: ' + e.Name + ' at postion: ' + ft );
      j := j + 1;
    end;
    i := i + 1;
  end;
end;

end.
