unit ZoomAndTranslationDocument;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, vg_TLB;

type
  TfrmZoomAndTranslationDocument = class(TForm)
    vg1: Tvgctrl;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmZoomAndTranslationDocument: TfrmZoomAndTranslationDocument;

implementation

{$R *.dfm}

procedure TfrmZoomAndTranslationDocument.FormShow(Sender: TObject);
begin
  vg1.Run( 'http://www.visual-graph.com/activex/map.xml' );
end;

procedure TfrmZoomAndTranslationDocument.Button1Click(Sender: TObject);
begin
  vg1.vg.ZoomFit();
end;

procedure TfrmZoomAndTranslationDocument.Button2Click(Sender: TObject);
begin
  vg1.vg.ZoomIn();
end;

procedure TfrmZoomAndTranslationDocument.Button3Click(Sender: TObject);
begin
  vg1.vg.ZoomOut();
end;

procedure TfrmZoomAndTranslationDocument.Button4Click(Sender: TObject);
begin
  vg1.vg.MoveSheet();
end;

procedure TfrmZoomAndTranslationDocument.Button5Click(Sender: TObject);
var
  dlg : Ivg;
  p : TPoint;
begin
  GetCursorPos( p );
  dlg := vg1.vg.Create( vg1.DefaultPath + 'smallview.tbl', true, false );
  dlg.ActiveSheet.SetPropertyValue( 'cursheet', vg1.vg.ActiveSheet );
  dlg.Popup( p.x, p.y );
  dlg.Free();
end;

procedure TfrmZoomAndTranslationDocument.Button6Click(Sender: TObject);
var
  i, j, n : Integer;
  st : ISheet;
  d : IUnit;
  x, y : double;
begin
	for i := 0 to vg1.vg.SheetCount - 1 do
	begin
		st := vg1.vg.Sheets[i];
		n := st.UnitCount;
		for j := 0 to n - 1 do
		begin
			d := st.Units[j];
			if not d.IsElement() then
			begin
			  if Pos( 'building', d.Text ) > 0 then
			  begin
				  vg1.vg.ActiveSheet := st;
          vg1.vg.Zoom := d.ZoomMin + 1;
				  vg1.vg.Selection.Clear();
				  vg1.vg.Selection.Add( d );
          x := d.XOrigin;
          y := d.YOrigin;
				  vg1.vg.ScrollToCenter( x, y );
				  ShowMessage( d.Text );
				  Exit;
			  end;
			end;
		end;
	end;
end;

end.
